/*
 * parse_arguments.c --implements function for parsing a command-line string
 * into the program arguments contained within it.
 *
 * Authored by Joshua Saxby
 */
#include <stddef.h>
#include <string.h>

#include "userprog/argument_parsing.h"


int parse_arguments(const char* command_line, char**argv) {
    int argc = 0;
    // the state pointer required by strtok_r() for use between calls
    char* state_pointer;
    // first call to strtok_r() is the only one where string to parse is passed
    argv[0] = strtok_r(command_line, " ", &state_pointer);
    argc++;
    // now, parse token-by-token for any additional arguments
    char* token = strtok_r(NULL, " ", &state_pointer);
    // continue while still tokens to read and maximum arg count is not reached
    while (token != NULL && argc < USERPROG_ARGV_COUNT) {
        argv[argc] = token;
        argc++;
        token = strtok_r(NULL, " ", &state_pointer);
    }
    return argc;
}
