/*
 * Returns the size, in bytes, of the file open as fd.
 *
 * Authored by Alex Stratford
 */
#include <stddef.h>
#include "system_calls.h"
#include "filesys/file.h"

void syscall_filesize(struct intr_frame *f) {
	// pop off first int argument from interrupt frame
	int file_descriptor = *((int*)f->esp + 1);
	struct file *file = get_associated_file_pointer(file_descriptor);
	if (file == NULL) { // Checking if file is empty or non-existent
		f->eax -1; // Returning failure state
		return;
	}
	// Using the file_length function in file.h to get the length and store it
	int size = file_length(file); 
	f->eax = size;
}
