/*
 * Returns the current offset into the file that the given file descriptor is at
 *
 * Authored by Joshua Saxby
 */
#include <stddef.h>
#include "system_calls.h"
#include "filesys/file.h"

void syscall_tell(struct intr_frame *f) {
	// pop off first int argument from interrupt frame
	int file_descriptor = *((int*)f->esp + 1);
	struct file *file = get_associated_file_pointer(file_descriptor);
    /*
     * tell() return type is unsigned so we can't return a special error code if
     * file descriptor passed is invalid. Instead, we return 0 silently.
     */
	f->eax = (file != NULL) ? file_tell(file) : 0;
}
